﻿namespace CodeSamples.Ch01_ServiceOrientedArchitecture.Listing1
{
  /// <summary>
  /// Interfaces only describe the properties, indexers,
  /// methods, and events that a class exposes for use.
  /// Logic to implement these features is not allowed in 
  /// an interface.
  /// </summary>
  public interface IExample
  {
    /// <summary>
    /// Example of a string property the implementing class
    /// must provide.
    /// </summary>
    string StringProperty { get; set; }

    /// <summary>
    /// Example of a read-only property
    /// </summary>
    string ReadOnlyStringProperty { get; }

    /// <summary>
    /// Example of a methods that accepts two parameters.
    /// </summary>
    int OperateOnTwoNumbers(int pNum1, int pNum2);
  }

}
