﻿using CodeSamples.Ch01_ServiceOrientedArchitecture.Listing1;

namespace CodeSamples.Ch01_ServiceOrientedArchitecture
{
  /// <summary>
  /// This is a second implementation of the IExample interface.
  /// It has no relation to the other implementation, and can
  /// implement completely different logic.
  /// </summary>
  public class AlternateExample : IExample
  {
    /// <summary>
    /// The string property is the same as the previous implementation
    /// </summary>
    public string StringProperty { get; set; }

    /// <summary>
    /// The ReadOnlyStringProperty will always return the
    /// given value
    /// </summary>
    public string ReadOnlyStringProperty
    {
      get { return "I'm an Alternate"; }
    }

    /// <summary>
    /// This method operates on the two inputs in a different
    /// way, returning a completely different result than our 
    /// previous implementation.
    /// </summary>
    public int OperateOnTwoNumbers(int pNum1, int pNum2)
    {
      return pNum1 * pNum2;
    }
  }


}

