﻿
using System;
using System.Collections.Generic;

namespace CodeSamples.Ch01_ServiceOrientedArchitecture
{


/// <summary>
/// Class representing the process of buying an item
/// </summary>
public class SalesclerkWithState
{
  private List<Purchase> _rememberedPurchases;

  public SalesclerkWithState()
  {
    _rememberedPurchases = new List<Purchase>();
  }

  /// <summary>
  /// Method to call when a customer is buying an item
  /// </summary>
  public void SellItem(string itemToSell, string nameOfPurchaser)
  {
    var purchase = new Purchase();
    purchase.PurchaserName = nameOfPurchaser;
    purchase.SaleDate = DateTime.Today;
    purchase.ItemSold = itemToSell;
    purchase.AmountPaid = GetItemPrice(itemToSell);
    ReceiveOrRefundPayment(purchase.AmountPaid);
    _rememberedPurchases.Add(purchase);
  }

  /// <summary>
  /// method to call when the customer is returning the item
  /// </summary>
  public void ReturnItem()
  {
    var purchase = RememberItemSoldToCustomer();
    ReceiveOrRefundPayment(-purchase.AmountPaid);
  }

  /// <summary>
  /// Charge the customer credit card for the purchase
  /// </summary>
  private Purchase RememberItemSoldToCustomer()
  {
    //recall the customer and how much they paid
    return _rememberedPurchases[0];
  }

  /// <summary>
  /// Interacts with the customer to get the credit card number
  /// </summary>
  private void ReceiveOrRefundPayment(double amount)
  {
    //Get the payment from the customer
  }

  /// <summary>
  /// Lookup the price of the item and return it
  /// </summary>
  private double GetItemPrice(string itemToSell)
  {
    //lookup the price of the item and return it
    return 154.00;
  }

  private class Purchase
  {
    public string PurchaserName { get; set; }
    public double AmountPaid { get; set; }
    public DateTime SaleDate { get; set; }
    public string ItemSold { get; set; }
  }
}

}