﻿
using System;

namespace CodeSamples.Ch01_ServiceOrientedArchitecture
{


/// <summary>
/// Class representing the process of buying a shirt
/// </summary>
public class SalesClerkWithNoState
{
  /// <summary>
  /// Method to call when a customer is buying an item
  /// </summary>
  public SalesReceipt SellItem(string itemToSell)
  {
    var receipt = new SalesReceipt();
    receipt.SaleDate = DateTime.Today;
    receipt.ItemSold = itemToSell;
    receipt.AmountPaid= GetItemPrice(itemToSell);
    ReceiveorRefundPayment(receipt.AmountPaid);
    return receipt;
  }

  /// <summary>
  /// method to call when the customer is returning the item
  /// </summary>
  public void ReturnItem(SalesReceipt receipt)
  {
    GetReceiptAndItemFromCustomer();
    ReceiveorRefundPayment(-receipt.AmountPaid);
  }

  /// <summary>
  /// Get the necessary items from the customer
  /// </summary>
  private void GetReceiptAndItemFromCustomer()
  {
    //receive the item and receipt from customer
  }

  /// <summary>
  /// Interacts with the customer to get the credit card number
  /// </summary>
  private void ReceiveorRefundPayment(double amount)
  {
    //Get the payment from the customer
  }

  /// <summary>
  /// Lookup the price of the item and return it
  /// </summary>
  private double GetItemPrice(string itemToSell)
  {
    //lookup the price of the item and return it
    return 154.00;
  }
}

/// <summary>
/// Reflects information about the purchase
/// </summary>
public class SalesReceipt
{
  public double AmountPaid { get; set; }
  public DateTime SaleDate { get; set; }
  public string ItemSold { get; set; }
}

}

