﻿using System.Collections.Generic;

namespace CodeSamples.Ch02_ApplicationArchitecture.Listing01
{

  public class SampleView 
  {
    private User User { get; set; }
    private ICollection<UserRole> AvailableRoles { get; set; }
    private int RequiredPasswordChars { get; set; }

    public SampleView (User usr, ICollection<UserRole> roles, int passwordLen)
    {
      this.User = usr;
      this.AvailableRoles = roles;
      this.RequiredPasswordChars = passwordLen;
    }

    public void Show()
    {
      //show the view
    }
  }

  public class SampleViewController
  {
    public SampleViewController()
    {
      var repo = new Repository();
      var usr = repo.GetUserInfo();
      var roles = repo.GetUserRoles();
      var passwordLen = repo.GetPasswordChars();
      var view = new SampleView(usr, roles, passwordLen);
      view.Show();
    }
  }

  public class Repository
  {
    public User GetUserInfo()
    {
      //get user info from DB
      return new User();
    }

    public List<UserRole> GetUserRoles()
    {
      //get user roles from DB
      return new List<UserRole>();
    }

    public int GetPasswordChars()
    {
      //get required password length from dB
      return 6;
    }
  }

  public class User
  {
    //user info goes here
  }

  public class UserRole
  {
    //security role info goes here
  }
}