﻿using System.Collections.Generic;

namespace CodeSamples.Ch02_ApplicationArchitecture.Listing03
{

  public class SampleView
  {
    private SampleViewModel _viewModel;

    public SampleView(SampleViewModel viewModel)
    {
      _viewModel = viewModel;
    }
    
    public void Show()
    {
      //show the view
    }
  }

  public class SampleViewController
  {
    public SampleViewController()
    {
      var repo = new Repository();
      var vm = new SampleViewModel(repo);
      var view = new SampleView(vm);
      view.Show();
    }
  }

  public class SampleViewModel
  {
    public User User { get; set; }
    public ICollection<UserRole> AvailableRoles { get; set; }
    public int RequiredPasswordChars { get; set; }

    public SampleViewModel(Repository repo)
    {
      this.User = repo.GetUserInfo();
      this.AvailableRoles = repo.GetUserRoles();
      this.RequiredPasswordChars = repo.GetPasswordChars();
    }
  }

  public class Repository
  {
    public User GetUserInfo()
    {
      //get user info from DB
      return new User();
    }

    public List<UserRole> GetUserRoles()
    {
      //get user roles from DB
      return new List<UserRole>();
    }

    public int GetPasswordChars()
    {
      //get required password length from dB
      return 6;
    }
  }

  public class User
  {
    //user info goes here
  }

  public class UserRole
  {
    //security role info goes here
  }

}