﻿using System;
using System.Windows.Forms;

namespace CodeSamples.Ch02_ApplicationArchitecture.Listing04
{
  public class SampleForm : Form
  {
    private DataGrid Grid;
    private Button showDetailsBtn;
    private Button maximizeWindowBtn;
    private ContextMenu mnu;

    public event EventHandler ShowDetailsButtonClicked;
    public event EventHandler MaximizeWindowButtonClicked;
    public event EventHandler ContextMenuItemClicked;

    public SampleForm()
    {
      Grid = new DataGrid();
      showDetailsBtn = new Button();
      maximizeWindowBtn = new Button();
      mnu = new ContextMenu();

      showDetailsBtn.Click += showDetailsBtn_Click;
      maximizeWindowBtn.Click += maximizeWindowBtn_Click;
      var mnuItem = mnu.MenuItems.Add("Details");
      mnuItem.Click += mnuItem_Click;
    }

    void maximizeWindowBtn_Click(object sender, EventArgs e)
    {
      if (MaximizeWindowButtonClicked != null) 
        MaximizeWindowButtonClicked(this, e);
    }

    void mnuItem_Click(object sender, EventArgs e)
    {
      if (ContextMenuItemClicked != null) ContextMenuItemClicked(this, e);
    }

    void showDetailsBtn_Click(object sender, EventArgs e)
    {
      if (ShowDetailsButtonClicked != null) ShowDetailsButtonClicked(this, e);
    }

    public void Maximize()
    {
      //maximize window
    }
  }

  public class SampleFormController
  {
    private SampleForm _form;
    public SampleFormController()
    {
      _form = new SampleForm();
      _form.ShowDetailsButtonClicked += _form_ShowDetailsButtonClicked;
      _form.ContextMenuItemClicked += _form_ContextMenuItemClicked;
      _form.MaximizeWindowButtonClicked += _form_MaximizeWindowButtonClicked;
    }

    void _form_MaximizeWindowButtonClicked(object sender, EventArgs e)
    {
      _form.Maximize();
    }

    void _form_ContextMenuItemClicked(object sender, EventArgs e)
    {
      ShowDetailsForm();
    }

    void _form_ShowDetailsButtonClicked(object sender, EventArgs e)
    {
      ShowDetailsForm();
    }

    private void ShowDetailsForm()
    {
      
    }
  }
}