﻿using System;
using System.Windows.Forms;

namespace CodeSamples.Ch02_ApplicationArchitecture.Listing05
{
  public class SampleForm : Form
  {
    private DataGrid Grid;
    private Button showDetailsBtn;
    private Button maximizeWindowBtn;
    private ContextMenu mnu;

    public event EventHandler ViewDetailsRequested;
    public event EventHandler MaximizeWindowButtonClicked;

    public SampleForm()
    {
      Grid = new DataGrid();
      showDetailsBtn = new Button();
      maximizeWindowBtn = new Button();
      mnu = new ContextMenu();

      showDetailsBtn.Click += showDetailsBtn_Click;
      maximizeWindowBtn.Click += maximizeWindowBtn_Click;
      var mnuItem = mnu.MenuItems.Add("Details");
      mnuItem.Click += mnuItem_Click;
    }

    void maximizeWindowBtn_Click(object sender, EventArgs e)
    {
      //maximize window
    }

    void mnuItem_Click(object sender, EventArgs e)
    {
      if (ViewDetailsRequested != null) 
        ViewDetailsRequested(this, e);
    }

    void showDetailsBtn_Click(object sender, EventArgs e)
    {
      if (ViewDetailsRequested != null) 
        ViewDetailsRequested(this, e);
    }

  }

  public class SampleFormPresenter
  {
    private SampleForm _form;
    public SampleFormPresenter()
    {
      _form = new SampleForm();
      _form.ViewDetailsRequested += _form_ShowDetailsButtonClicked;
    }

    void _form_ShowDetailsButtonClicked(object sender, EventArgs e)
    {
      ShowDetailsForm();
    }

    private void ShowDetailsForm()
    {
      
    }
  }
}