﻿
using Microsoft.Practices.Unity;

namespace CodeSamples.Ch04_DependencyInjectionPrinciple.Listing20
{
  public class Program
  {
    public Program()
    {
      var container = new UnityContainer();
      container.RegisterType<IParentClass, ParentClass>();
      container.RegisterType<IDependencyClass, DependencyClass>();

      var parent = container.Resolve<IParentClass>();
      parent.DoSomething();
    }
  }

  public interface IParentClass
  {
    void DoSomething();
  }

  public class ParentClass : IParentClass
  {
    private IDependencyClass _dependency;

    public ParentClass(IDependencyClass dependencyClass)
    {
      _dependency = dependencyClass;
    }

    public void DoSomething()
    {
      _dependency.DoSomethingElse();
    }
  }

  public interface IDependencyClass
  {
    void DoSomethingElse();
  }
  public class DependencyClass : IDependencyClass
  {
    public void DoSomethingElse()
    {
      //do the actual work
    }
  }

}