﻿
using System;

namespace CodeSamples.Ch09_LegacySolutionCleanup.Listing05
{

  public class FormController
  {
    public OrderLineItem CreateInventoryOrderLineItem(InventoryItem pItem,
            Customer pCustomer, int pQuantity, float pPrice)
    {
      if (pItem == null) throw new ArgumentException("Item is null");
      if (pCustomer == null) throw new ArgumentException("Customer is null");
      if (pItem.Discontinued) 
        throw new ArgumentException("Item Discontinued");
      if (pQuantity < 0) throw new ArgumentException("Invalid Quantity");
      if (pQuantity == 0 && !FreeSampleAllowed(pCustomer, pItem)) 
        throw new ArgumentException("Free Samples Not Allowed on this item");
      return new OrderLineItem(pItem, pQuantity, pPrice);
    }

    internal bool FreeSampleAllowed(Customer pCustomer, InventoryItem pItem)
    {
      return pCustomer.AllowFreeSamples && pItem.FreeSamplesAllowed;
    }

  }

  public class InventoryItem
  {
    public bool Discontinued { get; set; }
    public bool FreeSamplesAllowed { get; set; }
  }

  public class OrderLineItem
  {
    public OrderLineItem(InventoryItem item,
      int quanty, float price)
    {

    }
  }

  public class Customer
  {
    public bool AllowFreeSamples { get; set; }
  }
}