﻿using System;
using System.Windows.Forms;
using CodeSamples.Ch10_EstablishFoundation.Listing05;

namespace CodeSamples.Ch10_EstablishFoundation.Listing06
{
  /// <summary>
  /// This class already lives in the Shell project
  /// </summary>
  static class Program
  {
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main()
    {
      BootstrapperWinforms bootStrapper = null;

      try
      {
        Application.EnableVisualStyles();
        Application.SetCompatibleTextRenderingDefault(false);

        bootStrapper = new BootstrapperWinforms();
        bootStrapper.Run();
      }

      catch (Exception ex)
      {
        MessageBox.Show("Error occurred during application startup. "
        + "Application will now exit. Error details:\r\n " + ex);
        return;
      }

      try
      {
        // the cast is necessary in order to treat the Shell
        // as an interface for the rest of the app
        var shellController = bootStrapper.ShellController;
        var mainShellForm = shellController.View as Form;
        Application.Run(mainShellForm);
      }
      catch (Exception exc)
      {
        //this is where we handle exceptions that were
        //unhandled in the rest of the application.
      }
    }
  }
}