﻿using CodeSamples.Ch10_EstablishFoundation.Listing02;
using CodeSamples.Ch10_EstablishFoundation.Listing04;

namespace CodeSamples.Ch10_EstablishFoundation.Listing07
{

  public interface IShellFormViewModel
  {
    IShellForm View { get; }
    void Activate();
  }

  public class ShellFormViewModel : IShellFormViewModel
  {
    public IShellForm View { get; internal set; }
    public ShellFormViewModel()
    {
      View = ServiceLocator.Resolve<IShellForm>();
    }

    public void Activate()
    {
      //Child views must be resolved here instead of in
      //the constructor 
      //so view has time to register its regions
    }
  }

}