﻿using System.Windows.Forms;

namespace CodeSamples.Ch11_RefactorToBasicServices.Listing01
{
  /// <summary>
  /// The dialog service will show a message to the user
  /// and accept an appropriate response as requested
  /// by the caller
  /// </summary>
  public class DialogService : IDialogService
  {
    /// <summary>
    /// Show the given message to the user in a dialog
    /// with just an OK button
    /// </summary>
    public void Show(string pUserMessage)
    {
      MessageBox.Show(pUserMessage);
    }

    /// <summary>
    /// Show a message to the user with the specified
    /// window caption and buttons
    /// </summary>
    public DialogResult Show(string pUserMessage, string pCaption,
      MessageBoxButtons pMessageBoxButtons)
    {
      return MessageBox.Show(pUserMessage, pCaption, pMessageBoxButtons);
    }
  }

  public interface IDialogService
  {
    void Show(string pUserMessage);
    DialogResult Show(string pUserMessage, string pCaption,
      MessageBoxButtons pMessageBoxButtons);
  }
}