﻿using System;
using CodeSamples.Ch10_EstablishFoundation.Listing04;
using CodeSamples.Ch11_RefactorToBasicServices.Listing01;

namespace CodeSamples.Ch11_RefactorToBasicServices.Listing03
{
  public class BusinessLogicClass
  {
    /// <summary>
    /// Example of a method that can be refactored to use
    /// the dialog service.
    /// </summary>
    public bool ValidateDateRange(DateTime pStartDate, DateTime pEndDate)
    {
      if (pEndDate < pStartDate)
      {
        var dialogSvc = ServiceLocator.Resolve<IDialogService>();
        dialogSvc.Show("End Date must be after Start Date");
        return false;
      }
      return true;
    }
  }
}