﻿using System;
using CodeSamples.Ch10_EstablishFoundation.Listing04;
using CodeSamples.Ch11_RefactorToBasicServices.Listing01;

namespace CodeSamples.Ch11_RefactorToBasicServices.Listing04
{
  public class BusinessLogicClass
  {
    private IDialogService DialogSvc
    {
      get
      {
        return _dialogSvc ?? (
          _dialogSvc = ServiceLocator.Resolve<IDialogService>());
      }
    }
    private IDialogService _dialogSvc;


    /// <summary>
    /// Example of a method that can be refactored to use
    /// the dialog service.
    /// </summary>
    public bool ValidateDateRange(DateTime pStartDate, DateTime pEndDate)
    {
      if (pEndDate < pStartDate)
      {
        DialogSvc.Show("End Date must be after Start Date");
        return false;
      }
      return true;
    }
  }
}