﻿namespace CodeSamples.Ch11_RefactorToBasicServices.Listing08
{
  public class LegacyCodeSample
  {

    /// <summary>
    /// Legacy method of writing to a log file using
    /// a dedicated log writer class
    /// </summary>
    public void LegacyLogWriterCallUsingLogWriterClass()
    {
      LegacyLogWriter.Log("log this message");
    }

    /// <summary>
    /// Legacy method of writing to a log by accessing the
    /// file directly.
    /// </summary>
    public void LegacyLogWriterCallWritingDirectlyToFile()
    {
      using (var file = new System.IO.StreamWriter("c:\\test.txt"))
      {
        file.WriteLine("log this message");
        file.Close();
      }
    }
  }

  public static class LegacyLogWriter
  {
    private static string _logFileName = "c:\\test.txt";
    public static void Log(string msg)
    {
      using (var file = new System.IO.StreamWriter(_logFileName))
      {
        file.WriteLine(msg);
        file.Close();
      }
    }
  }

}