﻿using CodeSamples.Ch10_EstablishFoundation.Listing04;

namespace CodeSamples.Ch11_RefactorToBasicServices.Listing09
{
  public class LegacyCodeSample
  {
    /// <summary>
    /// Legacy method of writing to a log file using
    /// a dedicated log writer class
    /// </summary>
    public void LegacyLogWriterCallUsingLogWriterClass()
    {
      ServiceLocator.Resolve<ILegacyLogWriter>().Log("log this message");
    }

    /// <summary>
    /// Legacy method of writing to a log by accessing the
    /// file directly.
    /// </summary>
    public void LegacyLogWriterCallWritingDirectlyToFile()
    {
      ServiceLocator.Resolve<ILegacyLogWriter>().Log("log this message");
    }
  }

  public interface ILegacyLogWriter
  {
    void Log(string msg);
  }

  public class LegacyLogWriter : ILegacyLogWriter
  {
    private string _logFileName = "c:\\test.txt";
    public void Log(string msg)
    {
      using (var file = new System.IO.StreamWriter(_logFileName))
      {
        file.WriteLine(msg);
        file.Close();
      }
    }
  }

}