﻿
using CodeSamples.Ch10_EstablishFoundation.Listing04;

namespace CodeSamples.Ch11_RefactorToBasicServices.Listing13
{
  /// <summary>
  /// Static class before conversion to service
  /// </summary>
  public static class StaticServiceClass
  {
    private static int _variable;

    public static void StaticMethodCall()
    {
      _variable++;
    }
  }

  /// <summary>
  /// Static class after conversion to service
  /// </summary>
  public class NonStaticServiceClass : INonStaticServiceClass
  {
    private int _variable;

    public void NonStaticMethodCall()
    {
      _variable++;
    }
  }

  public interface INonStaticServiceClass
  {
    void NonStaticMethodCall();
  }

  public class ClassThatCallsStaticMethod
  {
    public void MethodCallingStaticClass()
    {
      //this is the old way of calling the method
      StaticServiceClass.StaticMethodCall();

      //replace the line above with this equivalent non-static call
      var svc = ServiceLocator.Resolve<INonStaticServiceClass>();
      svc.NonStaticMethodCall();
    }
  }
}