﻿using ADODB;

namespace CodeSamples.Ch12_RefactorToAdvancedServices.Listing01
{
  public class SecurityService
  {
    public bool ValidateUserPassword(int userId, string password)
    {
      var conn = new Connection();
      conn.ConnectionString = "connection string";
      conn.Open();

      var qryString = "select * from User where id = " + userId;

      var rs = new Recordset();
      rs.CursorLocation = CursorLocationEnum.adUseClient;
      rs.CursorType = CursorTypeEnum.adOpenForwardOnly;
      rs.LockType = LockTypeEnum.adLockOptimistic;
      rs.Open(conn, qryString);
      rs.ActiveConnection = null;

      //if locked out, fail
      if (rs.Fields["isLockedOut"].Value == "1") return false;

      //if password matches, succeed
      var validPW = (password == rs.Fields["password"].Value) ;

      //if last login was successful, no update needed
      var numBadLogins = int.Parse(rs.Fields["numBadLogins"].Value);
      var isLockedOut = int.Parse(rs.Fields["isLockedOut"].Value);
      if (validPW && numBadLogins == 0 && isLockedOut != 1) return true;

      //lock out user after 3 tries
      var updString = "update User set ";
      if (validPW)
      {
        updString += " numBadLogins = 0, isLockedOut = 0";
      }
      else
      {
        updString += " numBadLogins = numBadLogins + 1";
        if (numBadLogins >= 3)
          updString += " , isLockedOut = 1";
      }
      updString += " where id = " + userId;

      var cmd = new Command();
      cmd.CommandType = CommandTypeEnum.adCmdText;
      cmd.CommandText = updString;
      cmd.ActiveConnection = conn;
      object recordsAffected;
      cmd.Execute(out recordsAffected, null);

      return validPW;
    }

  }
}