﻿using System;
using System.Data.Entity;

namespace CodeSamples.Ch12_RefactorToAdvancedServices.Listing04
{
  public class ReengineeringEntities : DbContext
  {
    public ReengineeringEntities()
      : base("MyConnectionString")
    {
    }

    public DbSet<Address> Addresses { get; set; }
    public DbSet<Person> People { get; set; }
  }

  public class Address : BaseEntity
  {
    public int Id { get; set; }
    public string Address1 { get; set; }
    public string Address2 { get; set; }
    public string City { get; set; }
    public string State { get; set; }
    public string Zip { get; set; }
  }

  public class Person : BaseEntity
  {
    public int Id { get; set; }
    public string FirstName { get; set; }
    public string LastName { get; set; }
    public DateTime BirthDate { get; set; }
    public string Email { get; set; }
    public int Age
    {
      get
      {
        DateTime now = DateTime.Today;
        int age = now.Year - BirthDate.Year;
        if (BirthDate > now.AddYears(-age)) age--;
        return age;
      }
    }
    public Address HomeAddress { get; set; }
    public DateTime DateJoined { get; set; }
    public bool MembershipCancelled { get; set; }
  }

  public abstract class BaseEntity
  {
    public DateTime CreatedDate { get; set; }
    public DateTime UpdatedDate { get; set; }
  }
}