﻿using System;
using System.Linq;
using CodeSamples.Ch12_RefactorToAdvancedServices.Listing04;

namespace CodeSamples.Ch12_RefactorToAdvancedServices.Listing06
{
  public class Repository : IRepository
  {
    private ReengineeringEntities _context;

    public Repository()
    {
      _context = new ReengineeringEntities();
    }

    public IQueryable<Person> GetRecentlyJoinedUsers()
    {
      var people = (from p in _context.People
                    where p.DateJoined == DateTime.Today
                      && p.MembershipCancelled == false
                    select p);
      return people;
    }
  }

  public interface IRepository
  {
    IQueryable<Person> GetRecentlyJoinedUsers();
  }
}