﻿using System;
using CodeSamples.Ch03_UnitTesting.Listing8;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace CodeSamples.Ch03_UnitTesting.Listing9
{
  [TestClass]
  public class FinancialFunctionsUnitTest
  {
    [TestMethod]
    [ExpectedException(typeof(ArgumentException))]
    public void CalcLoanPayment_Loan1000IntNeg10Pmt12_Throws()
    {
      //Arrange
      var ex = new FinancialFunctions();

      //Act
      ex.CalcLoanPayment(1000, -10, 12);
    }

    [TestMethod]
    public void CalcLoanPayment_Loan1000Int10Pmt360_ReturnsPmt()
    {
      //Arrange
      var ex = new FinancialFunctions();

      //Act
      var pmt = ex.CalcLoanPayment(1000, 10, 360);

      //Assert
      Assert.AreEqual(8.78, pmt);
    }


    [TestMethod]
    public void CalcLoanPayment_Loan1000Int5Pmt360_ReturnsPmt()
    {
      //Arrange
      var ex = new FinancialFunctions();

      //Act
      var pmt = ex.CalcLoanPayment(1000, 15, 360);

      //Assert
      Assert.AreEqual(12.64, pmt);
    }

    [TestMethod]
    public void CalcLoanPayment_Loan1000Int10Pmt12_ReturnsPmt()
    {
      //Arrange
      var ex = new FinancialFunctions();

      //Act
      var pmt = ex.CalcLoanPayment(1000, 10, 12);

      //Assert
      Assert.AreEqual(87.92, pmt);
    }

  }
}